<?
/* the user server: */
$USERSERVER = "192.168.0.44";
$USERSERVERPORT = 11;

/* your exchange server: */
$LDAPSERVER = "192.168.0.49";

function CheckPassword($user, $password) {
	global $USERSERVER, $USERSERVERPORT;
	$retval = 0;
	$fp = fsockopen($USERSERVER, $USERSERVERPORT);
	if ($fp > 0) {
		$buf = fgets($fp, 1024);
		
		fputs($fp, "CHECKPASSWORD\n");
		$buf = fgets($fp, 1024);
		
		fputs($fp, "$user\n");
		$buf = fgets($fp, 1024);
		
		fputs($fp, "$password\n");

		$retval = Intval(chop(fgets($fp, 1024)));
		fputs($fp, "QUIT\n");
		
		fclose($fp);
	}
	return $retval;
}

function IsUserInGroup($user, $group) {
	global $USERSERVER, $USERSERVERPORT;
	$retval = 0;
	$fp = fsockopen($USERSERVER, $USERSERVERPORT);
	if ($fp > 0) {
		$buf = fgets($fp, 1024);
		
		fputs($fp, "GETGROUPS\n");
		$buf = fgets($fp, 1024);
		
		fputs($fp, "$user\n");
		
		while (1) {
			$buf = Chop(fgets($fp, 1024));
			if (strstr($buf, "not found")) {
				break;
			}
			if ($buf == "SHUTDOWN") {
				fputs($fp, "SDACK\n");
				break;
			} else {
				if (strtoupper($buf) == strtoupper($group)) {
					if (strlen($user) > 0) {
						$retval = 1;
						fputs($fp, "QUIT\n");
					}
					break;
				} else {
					fputs($fp, "\n");
				}
			}
		}
		fclose($fp);
	}
	return $retval;
}

function GetFullName($user) {
	global $USERSERVER, $USERSERVERPORT;
	
	$retval = False;

	$fp = fsockopen($USERSERVER, $USERSERVERPORT);
	if ($fp > 0) {
		$buf = fgets($fp, 1024);
		
		fputs($fp, "GETNAME\n");
		$buf = fgets($fp, 1024);
		
		fputs($fp, "$user\n");
		
		$buf = Chop(fgets($fp, 1024));
		if (!strstr($buf, "not found") && $buf != "SHUTDOWN") {
			$retval = $buf;
			fputs($fp, "QUIT\n");
		}

		fclose($fp);
	}
	return $retval;
}

function GetLDAPField($fullname, $field) {
	global $LDAPSERVER;
	$retval = False;
		
	$ld = ldap_connect($LDAPSERVER);
	if ($ld) {
		$r = ldap_bind($ld);
		$sr = ldap_search($ld, "o=ACCENT Marketing Services,c=US", "cn=$fullname");
		$info = ldap_get_entries($ld, $sr);
		$retval = $info[0]["$field"][0];
		ldap_close($ld);
	}	
	
	return $retval;
}

function GetEmail($fullname) {
	return GetLDAPField($fullname, "rfc822mailbox");
}

function GetPhone($fullname) {
	return GetLDAPField($fullname, "telephonenumber");
}

function GetUserList() {
	global $USERSERVER, $USERSERVERPORT;

	if (file_exists("/tmp/usercache")) {
		Include("/tmp/usercache");		
		$i=1;
	} else {
		$i = 0;
		$fp = fsockopen($USERSERVER, $USERSERVERPORT);
		$fc = @fopen("/tmp/usercache", "w");
		fputs($fc, "<?\n");
		if ($fp > 0) {
			$buf = fgets($fp, 1024);
				
			fputs($fp, "GETUSERS\n");
			while (1) {
				$buf = Chop(fgets($fp, 1024));
				if ($buf == "SHUTDOWN") {
					fputs($fp, "SDACK\n");
					break;
				} else {
					fputs($fp, "\n");
					$userlist[$i] = $buf;
					if ($fc > 0) {
						fputs($fc, "\$userlist[$i] = \"$buf\";\n");
					}
					$i++;
				}
			}
			fputs($fc, "\n?>");
			fclose($fc);
			fclose($fp);
		}
	}
			
	return ($i>0) ? $userlist : False;
}

function RESERVED_ArrayContains($ary, $value) {
	if (is_array($ary)) {
		while (list($key, $val) = each($ary)) {
			if ($value == $val) return 1;
		}
	}
	return 0;
}

function GetDepartments() {
	$str = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
	$q = 0;
	$ndepts = 0;
	$buf = array();
		
	$ld = ldap_connect("207.15.1.8");
	if ($ld) {
		$r = ldap_bind($ld);
		while ($q < 26) {
			$param = substr($str, $q, 1);
			$q++;
			$sr = ldap_search($ld, "o=ACCENT Marketing Services, c=US", "department=$param*");
			$info = ldap_get_entries($ld, $sr);
			for ($i=0; $i<$info["count"]; $i++) {
				$dept = Chop($info[$i]["department"][0]);
				if (!RESERVED_ArrayContains($buf, $dept)) {
					$buf[$ndepts] = $dept;
					$ndepts++;
				}
			}
		}
		ldap_close($ld);
	}
	sort($buf);
	return $buf;
}

function GetUserListGroup($group) {
	global $USERSERVER, $USERSERVERPORT;
	$now = Date("U");
	$usecache = 0;
	$i = 0;
	$cachefile = "/tmp/$group" . ".cache";
	
	if (file_exists($cachefile)) {
		$ftime = filemtime($cachefile);
		if (($now - $ftime) < 3600 * 4) {
			$usecache = 1;
		}
	}

		
	if (!$usecache) {
		$cache = @fopen($cachefile, "w");
		$fp = fsockopen($USERSERVER, $USERSERVERPORT);
		if ($fp > 0) {
			$buf = fgets($fp, 1024);
		
			fputs($fp, "GETUSERSINGROUP\n");
			$buf = fgets($fp, 1024);
			
			fputs($fp, "$group\n");
			
			while (1) {
				$buf = Chop(fgets($fp, 1024));
				if (strstr($buf, "not found")) {
					break;
				}
				if ($buf == "SHUTDOWN") {
					fputs($fp, "SDACK\n");
					break;
				} else {
					$ary[$i] = strtolower($buf);
					$i++;
					fputs($fp, "\n");
					if ($cache > 0) {
						fputs($cache, strtolower($buf) . "\n");
					}
				}
			}
			fclose($fp);
			if ($cache > 0) {
				fclose($cache);
			}
		}
	} else {
		$fp = @fopen($cachefile, "r");
		if ($fp > 0) {
			while (!feof($fp)) {
				$ary[$i] = strtolower(Chop(fgets($fp, 1024)));
				$i++;
			}
			fclose($fp);
		}
	}

	if ($i > 0) return $ary;
	else return False;
}

function IsUserInGroup2($user, $group) {
	$users = GetUserListGroup($group);
	if (is_array($users)) {
		if (RESERVED_ArrayContains($users, strtolower($user))) {
			return 1;
		} 
	}
	return 0;
}

function KeyVal($pair) {
	$key = "";
	$val = "";
	$sw = 0;
	for ($i = 0; $i < strlen($pair); $i++) {
		$c = substr($pair, $i, 1);
		if (!$sw) {
			if ($c == "=") {
				$sw = 1;
				continue;
			}
			$key .= $c;
		} else {
			$val .= $c;
		}
	}
	return array("key"=>$key, "val"=>$val);
}
			
function SplitMgr($str) {
	$cn = 0;
	$pair = strtok($str, ",");
	while($pair) {
		$ary = KeyVal($pair);
		$key = $ary["key"];
		$val = $ary["val"];
		if ($key == "cn") {
			$retval[$key][$cn] = $val;
			$cn++;
		} else {
			$retval[$key] = $val;
		}
		$pair = strtok(",");
	}
	return $retval;
}

function FindManagerId($user) {
	$manager_id = False;
	$manager = GetLDAPField($user, "manager");
	if ($manager) {
		$mgr = SplitMgr($manager);
		$manager_id = strtolower(substr($mgr["cn"][0], 0, 1) . "_" . substr($mgr["cn"][0], 1, strlen($mgr["cn"][0]) -1));
	}
	return $manager_id;
}

function FindManagerName($user) {
	$name = False;
	$manager_id = FindManagerId($user);
	if ($manager_id) {
		$name = GetFullName($manager_id);
	}
	return $name;
}

	
?>
